#include "SXSLTUtils.hpp"

#include <XSLT/XSLTProcessorEnvSupportDefault.hpp>
#include <XPath/XPathFunctionTable.hpp>

#include "RxslFunction.hpp"
#include "SXalanException.hpp"


#ifdef SET_XPATH_SUPPORT_FIELD
class SXPathEnvSupportDefault : public XPathEnvSupportDefault
{
    bool
	functionAvailable(
			const XalanDOMString&	theNamespace, 
			const XalanDOMString&	functionName) const {

           return(XPathEnvSupportDefault::functionAvailable(theNamespace, functionName));
   }


	virtual XObjectPtr
	extFunction(
			XPathExecutionContext&			executionContext,
			const XalanDOMString&			theNamespace,
			const XalanDOMString&			functionName, 
			XalanNode*						context,
			const XObjectArgVectorType&		argVec) const {

           return(XPathEnvSupportDefault::extFunction(executionContext,theNamespace, functionName, context, argVec));

  }
};
#endif

class XSLTEnvSupportExtension : public XSLTProcessorEnvSupportDefault
{
  public:
    XSLTEnvSupportExtension() : XSLTProcessorEnvSupportDefault() { 
#ifdef SET_XPATH_SUPPORT_FIELD
         XPathEnvSupportDefault v;
         setXPathEnvSupport(v);
#endif
    }

	virtual XObjectPtr
	extFunction(
			XPathExecutionContext&			executionContext,
			const XalanDOMString&			theNamespace,
			const XalanDOMString&			functionName, 
			XalanNode*				context,
			const XObjectArgVectorType&		argVec) const {

       try {
          return(XSLTProcessorEnvSupportDefault::extFunction(executionContext,
                                                             theNamespace, 
                                                             functionName, 
                                                             context, argVec));
       } catch(const XPathExceptionFunctionNotAvailable& e) {
#ifdef SXALAN_DEBUG
         fprintf(stderr, "Couldn't find function, looking in S\n");fflush(stderr);
#endif
         NamedRFunction func(getString(functionName));
         return(func.execute(executionContext, context, 0, argVec));
       }
  }

};

